SystemOrganization addCategory: #'Xenon-Tests'!

Object subclass: #XeEmptyMainWhenItHasManyReturnTypeScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenItHasManyReturnTypeScenario methodsFor: 'c code' stamp: 'BernardoContreras 2/27/2012 18:55'!
main
	<returnType: #XeIntType>
	<returnType: #XeVoidType>
! !

Object subclass: #XeEmptyMainWhenReturnTypeIsDefaultScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenReturnTypeIsDefaultScenario methodsFor: 'c code' stamp: 'BernardoContreras 2/26/2012 16:09'!
main
! !

Object subclass: #XeEmptyMainWhenReturnTypeIsIntegerScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenReturnTypeIsIntegerScenario methodsFor: 'c code' stamp: 'BernardoContreras 2/27/2012 18:54'!
main
	<returnType: #XeIntType>
! !

Object subclass: #XeEmptyMainWhenReturnTypeIsUnknownScenario
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeEmptyMainWhenReturnTypeIsUnknownScenario methodsFor: 'c code' stamp: 'BernardoContreras 3/19/2012 23:23'!
main
	<returnType: #unknown>
! !

TestCase subclass: #XeTranslateMainTest
	instanceVariableNames: 'xenon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Tests'!

!XeTranslateMainTest methodsFor: 'running' stamp: 'BernardoContreras 3/15/2012 23:04'!
setUp
	xenon := Xenon new! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 3/15/2012 23:04'!
testTranslateEmptyMainWhenItHasManyReturnTypes
	self should: [xenon translate: XeEmptyMainWhenItHasManyReturnTypeScenario] raise: XeTooManyReturnTypesError
! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 3/15/2012 23:04'!
testTranslateEmptyMainWhenReturnTypeIsDefault
	| actual expected |
	actual := xenon translate: XeEmptyMainWhenReturnTypeIsDefaultScenario.
	expected := 'void main(){
}'.
	self assert: actual equals: expected! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 3/15/2012 23:04'!
testTranslateEmptyMainWhenReturnTypeIsInteger
	| actual expected |
	actual := xenon translate: XeEmptyMainWhenReturnTypeIsIntegerScenario.
	expected := 'int main(){
}'.
	self assert: actual equals: expected! !

!XeTranslateMainTest methodsFor: 'tests' stamp: 'BernardoContreras 3/19/2012 23:44'!
testTranslateEmptyMainWhenReturnTypeIsUnknown
	
	self should: [xenon translate: XeEmptyMainWhenReturnTypeIsUnknownScenario] raise: XeTypeNotFoundError
! !
